% Interpolation
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 1D interpolation
  x = 0:10; 
  y = sin(x); 
  figure(1); plot(x,y,'o');
    xi = 0:.2:10; 
    yilin = interp1(x,y,xi); 
    yisp = interp1(x,y,xi,'spline'); 
    hold on; plot(xi,yilin,'g',xi,yisp,'r'); hold off
  title('1D INTERPOLATION'); grid on
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 2D interpolation
  [X,Y]=meshgrid(-2:0.5:2);
  Z=-X.*exp(-X.^2-Y.^2);
  figure(2); mesh(X,Y,Z);
    [XI,YI]=meshgrid(-2:0.1:2);
    ZI=interp2(X,Y,Z,XI,YI,'spline');
    hold on; mesh(XI,YI,ZI+1); hold off
  title('2D INTERPOLATION'); grid on; colormap([0 0 0])
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 2D data grid
  x=4*(rand(100,1)-0.5); y=4*(rand(100,1)-0.5);
  z=-x.*exp(-x.^2-y.^2)+0.5;
    [XI,YI]=meshgrid(-2:0.1:2);
    ZI=griddata(x,y,z,XI,YI);
  figure(3); mesh(XI,YI,ZI);
    hold on; stem3(x,y,z,'o'); hold off
  title('DATA GRID'); grid on;   